Transformations
-
TIG, Thanks. Hard to wrap my beginner's mind around this, have to experiment a lot to understand, especially with sub-components.
-
Yes... except 4) ???
and 5) If you want to flip and object apply ascaling
Transformation of-1
in the required axis about the required point... -
@honoluludesktop said:
TIG, Thanks. Hard to wrap my beginner's mind around this, have to experiment a lot to understand, especially with sub-components.
To Mirror/Flip something about a Point in a given Axis then the Transformation is a Scaling -1...
-
All right, this is a dusty old post I'm digging up here...
My problem seems very common but I curiously found nothing to solve it so far. Doesn't mean the answer isn't located somewhere though, but I haven't found it.I am still trying to have a plane flying and it is going in a good direction thanks to Pixero, Fred and Morsidov's work on the subject.
I needed the absolute 3D position of my object, and I found how to do it (thx thomthom).
HOWEVER
I am still struggling in retrieving the absolute 3D orientation of my object.
I would have expect such info to be completely basic in a 3D editor, yet it doesn't seem that easy to find.Any help welcome !
-
In the same way my example took the local 3d position and transformed it with the combined transformation for all the containing groups/components you must apply the combined transformation to your vector of orientation/direction.
-
rrright... I'm not able to digest that comment just yet. (waiting for my dinner) ... But , about your airplane...
You're making an airplane fly around following a path?
Are you transforming the edges and faces themself to make it fly? or are you transforming a group/component containing the plane?
How do you control the plane? control path?
(Just trying to get the general scheme of what you are doing before getting into the nitty gritty coding details.)
-
@thomthom said:
rrright... I'm not able to digest that comment just yet. (waiting for my dinner) ... But , about your airplane...
Oh ! sorry
@thomthom said:
You're making an airplane fly around following a path? Are you transforming the edges and faces themself to make it fly? or are you transforming a group/component containing the plane?
How do you control the plane? control path?
(Just trying to get the general scheme of what you are doing before getting into the nitty gritty coding details.)All right, I will explain.
I don't use any transformation on edges and faces because it is really too low level for my animation, I just take the plane as a solid object and have it fly like this, without internal animation.My purpose is to have a plane flying in a close room and the camera followin it so that it is always in the field of view, from behind, in a tenth of the image maybe. I want to have a video of 25s out of it.
What I did first was to create a close loop as a Bézier spline using Fredo6's impressive tool.
Secondly I used Pixero's BZ_animator to get the camera follow the flypath and the scenes created accordingly.
You may say that it is not very convenient to have something like 600 scenes (aka frames) but as SketchUp first move the camera, THEN your object, I had to use it like this. I simply set the transition time 1/25s.Thirdly, I had to move my plane along the camera path, and I didn't find anything to do it properly so I just grab an older version of Morisdov's Proper Animation to understand the mechanism he was using. So far, I can move the plane along the spline/flypath, so it's working rather fine.
All I have to do to have something correct is to deal with the orientations: so far only the position of the plane changes.I haven't thought of my script as something that could be re-usable by other users so far, so my developments are completly focused on my goal. But once I have something decent I'll post it somewhere so that others can see what I did and may propose enhancements or other ways to do this.
-
Right. And you need the orientation of your plane group. The transformation class has an
axes
method that I think could be used to get your bearings. -
I don't really see how, TT...
In the meantime, to illustrate what I say:
-
If your plane is a component, then I believe it's orientation if constant based on how the component axes were defined originally. If your plane is not entering the model with consistent orientation, that suggest your placement transformation is rotating it rather than doing a strict translation. Once you've discerned your original orientation, it should be a simple matter of adding a rotation to orient the nose to the directional tangent to the spline then having your "up" vector rotate around the tangent until its parallel to the z-axis.
-
@cleverbeans said:
If your plane is a component, then I believe it's orientation if constant based on how the component axes were defined originally. If your plane is not entering the model with consistent orientation, that suggest your placement transformation is rotating it rather than doing a strict translation. Once you've discerned your original orientation, it should be a simple matter of adding a rotation to orient the nose to the directional tangent to the spline then having your "up" vector rotate around the tangent until its parallel to the z-axis.
Thanks Cleverbeans! Yes indeed you're right, if I have the initial orientation of my plane I should be able to retrieve the orientation at any time... And I may do this in the end but I'm not too fond of this.
First because I don't really know the place of my plane at the first frame (cause I placed the plane and scaled it in the room to fit my purpose).
And secondly, (I could but) I will not place my plane at the origin with the right orientation and put my scene around just because there is no simple way to find the actual orientation of a selected component! I feel like it's really a basic feature to be able to know the precise location and orientation (and, to be exhaustive, scale) of my component at any time. Plus I will further add other planes and may have to do more complicated things in the future.So I am really looking for a mean to find the exact orientation of a component at any time.
-
However, Cleverbeans, an idea would be to integrate my plane as an external component and tailor the parameters so that it fits in my scene... That can be an idea, but I'll look into that once I'm desesperate !
-
@zitoun said:
@thomthom said:
The transformation class has an
axes
method that I think could be used to get your bearings.As I see it,
Transformation::axes
method only enables to SET the axes, unfortunately not to GET them...
Sorry - I refereed to the wrong methods.
instead, usexaxis
,yaxis
andzaxis
http://code.google.com/apis/sketchup/docs/ourdoc/transformation.html#xaxisand of course the
origin
:
http://code.google.com/apis/sketchup/docs/ourdoc/transformation.html#originEverything is there in the transformation object.
-
@thomthom said:
The transformation class has an
axes
method that I think could be used to get your bearings.As I see it,
Transformation::axes
method only enables to SET the axes, unfortunately not to GET them...
EDIT: but maybe I should just SET the initial transformation, just like that... OK, let's try this.
But I still think it should be a standard feature to get the absolute or relative rotation matrix/quaternion for any component of the scene...RE-EDIT: I hadn't seen
Transformation::Xaxis
,Yaxis
andZaxis
method!
I have no clue what these are yet, but I guess I somehow can retrieve my rotation matrix from such component... -
@thomthom said:
In the same way my example took the local 3d position and transformed it with the combined transformation for all the containing groups/components you must apply the combined transformation to your vector of orientation/direction.
Sure thomthom, I get that. My pb is deeper... OK, I have to give the details! Here is what I understood so far:
An object has a 4x4 transformation matrix M attached that combines three parameters defining the geometrical state of the object:
- the position T in space
- the orientation R
- the scale S
Let's say I want to rotate my object (entity is the correct term I think) without changing the position: I will have to
- apply to M the inverse of the translation T (so far I use [0,0,0]-T)
Sketchup.active_model.active_entities.transform_entities(ORIGIN-fromPos,e) #puts the objet at the origin
- then apply the relative orientation dR I need
Sketchup.active_model.active_entities.transform_entities(Geom::Transformation.rotation(ORIGIN,UP,angle),e)
- and finally apply back the translation T.
You may say I should simply use the M.inverse but I think the scale factor would be a probl****em... Or not? (testing around) ... All right. Seems we can simply do :
- apply M.inverse,
Sketchup.active_model.active_entities.transform_entities(e.transformation.inverse,e)
- apply dR
- apply M back
Should be OK.
And here comes my tiny problem: current orientation R of the object is somehow melted with the other parameters T and S in global my transformation matrix M... How the hell do I get a proper orientation R?
Cause I already know the final absolute orientation R' I want my object (or entity, or, in my case, a good old german biplane) to reach: all I need is this initial orientation R to compute the difference dR.I thought to just get rid of the transformation, discard it and return to the identity and thus apply directly the wanted orientation R', then the position T. But it would be too easy: to fit in a small room, my plane had to be scaled, and I then need to know this scale factor S (that I otherwise simply ignore).
This special line is to thank the reader for the effort he put to read my reply.
And this one is for the people that would give me some clues: I owe you! -
OK, I surrender, I chose Cleverbeans method in the end, which revealed to be quite fine to do:
I re-initialized my plane transformation, then I scale it with a factor of 1/2 several time, until I had the right size (1/32 in the end). I then chose a reference rotation to position the plane as I wanted to in the first place. I then have an "initialTransformation" that I will have to apply each time BEFORE the other regular transformation.So for each frame I'll have
e.transform!( e.transformation.inverse ) e.transform!( initialTransformation ) e.transform!( transformationAtSuchFrame ) #with transformationAtSuchFrame combining a rotation and a translation
Now I am not depending anymore of a random initial state.
Of course I will rather combine all the intermediate matrices and then apply once the resulting transformation, it should be quicker.EDIT: I may have a quicker solution, that I still have to validate:
Geom::Transformation.origin
method gives the translation to put the object at the origin (and then be able to perform a simple rotation).
I might use this rather than combine several 4x4 matrix, it has to be a lot quicker ! -
@zitoun said:
e.transform!( e.transformation.inverse )
e.transform!( initialTransformation )This seems like it can be reduced to
e.transformation = initialTransformation
and that could possibly be reduced to:
e.transformation = initialTransformation * transformationAtSuchFrame
-
@thomthom said:
This seems like it can be reduced to
e.transformation = initialTransformation
and that could possibly be reduced to:
e.transformation = initialTransformation * transformationAtSuchFrame
Really?
I thought I had tested this solution and my results were not conclusive.
But maybe I was too tired: I'm gonna try again ! -
If you always calculate from one fixed state then there is no need to undo the current transformation, you just set a new transformation overriding the old one.
-
@thomthom said:
If you always calculate from one fixed state then there is no need to undo the current transformation, you just set a new transformation overriding the old one.
Yes indeed, but for some reason I thought that the method
entity.transformation=
was working differently (but I may have been really tired at the time I tested it).
It completely make sense that it works the way you describe it.
Advertisement